import x from "fetch-retry";
const m = x(fetch, {
  retries: 0,
  retryDelay: function(t) {
    return Math.pow(2, t) * 15e3;
  }
});
async function* o(t, e, r) {
  let s = 1;
  for (; ; ) {
    let u;
    try {
      u = await m(`${t}?page=${s}${r.finalQuery}`, {
        retries: 5,
        method: "GET",
        headers: {
          Authorization: `Bearer ${e}`
        }
      });
    } catch (p) {
      const y = {};
      throw y[p.constructor.name] = [p.message], y;
    }
    const i = await u.json();
    if (u.ok && i) {
      if (u.headers.get("x-total-pages") === s.toString())
        return i;
      yield i;
    } else
      throw i;
    s++;
  }
}
async function h(t, e, r) {
  const s = new Request(t, {
    ...r,
    method: "GET",
    headers: {
      Authorization: `Bearer ${e}`
    }
  });
  return await d(s);
}
async function n(t, e, r) {
  const s = new Request(t, {
    method: "POST",
    headers: {
      "content-type": "application/json",
      Authorization: `Bearer ${e}`
    },
    body: JSON.stringify(r)
  });
  return await d(s);
}
async function S(t, e, r) {
  const s = new Request(t, {
    method: "PATCH",
    headers: {
      "content-type": "application/json",
      Authorization: `Bearer ${e}`
    },
    body: JSON.stringify(r)
  });
  return await d(s);
}
async function $(t, e) {
  const r = new Request(t, {
    method: "DELETE",
    headers: {
      Authorization: `Bearer ${e}`
    }
  });
  return await d(r);
}
async function d(t) {
  let e, r;
  try {
    e = await m(t), r = e.status === 204 ? !0 : await e.json();
  } catch (s) {
    const u = {};
    throw u[s.constructor.name] = [s.message], u;
  }
  if (e.ok)
    return r;
  throw r;
}
class c {
  constructor() {
    this.scopes = [];
  }
  get finalQuery() {
    return this.scopes.map((e) => `&${e.key}=${e.query}`).join("");
  }
  addScope(e, r) {
    return this.scopes.push({ key: e, query: r }), this;
  }
  addScopesFromArray(e, r) {
    return r.forEach((s) => this.addScope(e, s)), this;
  }
}
class g extends c {
  artist(e) {
    return this.addScope("artist_id", e);
  }
  filter(e) {
    return this.addScope("filter", e);
  }
  label(e) {
    return this.addScope("label", e);
  }
  labels(e) {
    return this.addScopesFromArray("labels", e);
  }
}
class _ extends c {
  filter(e) {
    return this.addScope("filter", e);
  }
}
class w extends c {
  album(e) {
    return this.addScope("album_id", e);
  }
  artist(e) {
    return this.addScope("artist_id", e);
  }
  playedBefore(e) {
    return this.addScope("played_before", e.toISOString());
  }
  playedAfter(e) {
    return this.addScope("played_after", e.toISOString());
  }
}
class M extends c {
  album(e) {
    return this.addScope("album_id", e);
  }
  artist(e) {
    return this.addScope("artist_id", e);
  }
  filter(e) {
    return this.addScope("filter", e);
  }
  genre(e) {
    return this.addScope("genre_id", e);
  }
}
class l {
  constructor(e, r) {
    this.path = r, this.baseURL = e;
  }
  get url() {
    return `${this.baseURL}/${this.path}`;
  }
}
class f extends l {
  index(e) {
    return o(this.url, e, new c());
  }
  async create(e, r) {
    return await n(this.url, e, r);
  }
  async read(e, r, s = {}) {
    return await h(
      `${this.url}/${r}`,
      e,
      s
    );
  }
  async destroy(e, r) {
    return await $(`${this.url}/${r}`, e);
  }
}
class a extends f {
  async update(e, r, s) {
    return await S(
      `${this.url}/${r}`,
      e,
      s
    );
  }
}
class E extends a {
  constructor(e) {
    super(e, "albums");
  }
  index(e, r = new g()) {
    return o(this.url, e, r);
  }
  async destroyEmpty(e) {
    return await n(
      `${this.url}/destroy_empty`,
      e,
      {}
    );
  }
  async merge(e, r, s) {
    return await n(
      `${this.url}/${r}/merge?source_id=${s}`,
      e,
      {}
    );
  }
}
class A extends a {
  constructor(e) {
    super(e, "artists");
  }
  index(e, r = new _()) {
    return o(this.url, e, r);
  }
  async destroyEmpty(e) {
    return await n(
      `${this.url}/destroy_empty`,
      e,
      {}
    );
  }
  async merge(e, r, s) {
    return await n(
      `${this.url}/${r}/merge?source_id=${s}`,
      e,
      {}
    );
  }
}
class v extends l {
  constructor(e) {
    super(e, "auth_tokens");
  }
  index(e) {
    return o(this.url, e, new c());
  }
  async create(e) {
    return await n(this.url, "", e);
  }
  async read(e, r, s = {}) {
    return await h(
      `${this.url}/${r}`,
      e,
      s
    );
  }
  async destroy(e, r) {
    return await $(`${this.url}/${r}`, e);
  }
}
class C extends a {
  constructor(e) {
    super(e, "codec_conversions");
  }
}
class q extends a {
  constructor(e) {
    super(e, "codecs");
  }
}
class B extends a {
  constructor(e) {
    super(e, "cover_filenames");
  }
}
class b extends a {
  constructor(e) {
    super(e, "genres");
  }
  async destroyEmpty(e) {
    return await n(
      `${this.url}/destroy_empty`,
      e,
      {}
    );
  }
  async merge(e, r, s) {
    return await n(
      `${this.url}/${r}/merge?source_id=${s}`,
      e,
      {}
    );
  }
}
class D extends a {
  constructor(e) {
    super(e, "image_types");
  }
}
class O extends a {
  constructor(e) {
    super(e, "labels");
  }
  async destroyEmpty(e) {
    return await n(
      `${this.url}/destroy_empty`,
      e,
      {}
    );
  }
  async merge(e, r, s) {
    return await n(
      `${this.url}/${r}/merge?source_id=${s}`,
      e,
      {}
    );
  }
}
class j extends f {
  constructor(e) {
    super(e, "locations");
  }
}
class k extends a {
  constructor(e) {
    super(e, "playlists");
  }
  async addItem(e, r, s) {
    return await n(`${this.url}/${r}/add_item`, e, s);
  }
}
class z extends l {
  constructor(e) {
    super(e, "plays");
  }
  index(e, r = new w()) {
    return o(this.url, e, r);
  }
  async create(e, r) {
    return await n(this.url, e, r);
  }
  stats(e, r = new w()) {
    return o(
      `${this.url}/stats`,
      e,
      r
    );
  }
}
class G extends l {
  constructor(e) {
    super(e, "rescans");
  }
  index(e) {
    return o(this.url, e, new c());
  }
  async startAll(e) {
    return await n(
      this.url,
      e,
      {}
    );
  }
  async start(e, r) {
    return await n(
      `${this.url}/${r}`,
      e,
      {}
    );
  }
  async show(e, r, s = {}) {
    return await h(`${this.url}/${r}`, e, s);
  }
}
class I extends a {
  constructor(e) {
    super(e, "tracks");
  }
  index(e, r = new M()) {
    return o(this.url, e, r);
  }
  async destroyEmpty(e) {
    return await n(
      `${this.url}/destroy_empty`,
      e,
      {}
    );
  }
  async merge(e, r, s) {
    return await n(
      `${this.url}/${r}/merge?source_id=${s}`,
      e,
      {}
    );
  }
}
class T extends a {
  constructor(e) {
    super(e, "users");
  }
}
var F = /* @__PURE__ */ ((t) => (t.ALBUM = "album", t.ARTIST = "artist", t.TRACK = "track", t))(F || {}), N = /* @__PURE__ */ ((t) => (t.SHARED = "shared", t.PERSONAL = "personal", t.SECRET = "secret", t))(N || {}), H = /* @__PURE__ */ ((t) => (t.main = "main", t.performer = "performer", t.composer = "composer", t.conductor = "conductor", t.remixer = "remixer", t.producer = "producer", t.arranger = "arranger", t))(H || {}), J = /* @__PURE__ */ ((t) => (t.user = "user", t.moderator = "moderator", t.admin = "admin", t))(J || {});
function Q(t) {
  return {
    albums: new E(t),
    artists: new A(t),
    auth_tokens: new v(t),
    codec_conversions: new C(t),
    codecs: new q(t),
    cover_filenames: new B(t),
    genres: new b(t),
    image_types: new D(t),
    labels: new O(t),
    locations: new j(t),
    playlists: new k(t),
    plays: new z(t),
    rescans: new G(t),
    tracks: new I(t),
    users: new T(t)
  };
}
export {
  E as AlbumModule,
  g as AlbumsScope,
  A as ArtistModule,
  _ as ArtistsScope,
  v as AuthTokenModule,
  C as CodecConversionModule,
  q as CodecModule,
  B as CoverFilenameModule,
  b as GenreModule,
  D as ImageTypeModule,
  O as LabelModule,
  j as LocationModule,
  z as PlayModule,
  N as PlaylistAccess,
  k as PlaylistModule,
  F as PlaylistType,
  w as PlaysScope,
  G as RescanModule,
  c as Scope,
  H as TrackArtistRole,
  I as TrackModule,
  M as TracksScope,
  T as UserModule,
  J as UserPermission,
  Q as createApiClient
};
//# sourceMappingURL=index.mjs.map
